<template>
  <div class="search container">
    <div class="columns">
      <div class="column">
        <h1 class="title is-6 filterTitle">Filters</h1>
        <Filters v-bind:tags="tags" v-on:setTags="setTags"/>
      </div>
      <div v-if="result" class="column is-four-fifths">
        <h1 class="title is-6 searchTitle">Search</h1>
        <b-field grouped>
          <b-input placeholder="Search..."
            type="search"
            icon="magnify"
            v-model="paramSearch"
            v-on:keyup.enter.native="setSearch"
            expanded
            />
          <b-select placeholder="Order by" icon="filter" @input="setOrder">
            <option value="votes">Most vote</option>
            <option value="lastModified">Most recent</option>
            <option value="performance">Best performance</option>
            <option value="parameterCount">Less parameters</option>
          </b-select>
        </b-field>
        <h1 class="title is-6">{{result.totalResult}} results - page {{result.page}} of {{result.totalPage}}</h1>
        <div v-for="model in result.models" v-bind:key="model.name">
          <ModelCard v-bind:model="model"/>
        </div>
        <b-pagination :total="result.totalResult" :current.sync="result.page" :per-page="resultSize" @change="changePage"/>
      </div>
      <div v-else class="column is-four-fifths">
        <h1 class="title">no modelo</h1>
      </div>
    </div>
    <b-loading :active.sync="isLoading" :is-full-page="false"/>
  </div>
</template>

<script>
import Filters from '@/components/Filters.vue'
import ModelCard from '@/components/ModelCard.vue'
import { api } from '@/api.js'

export default {
  name: 'Search',
  components: {
    Filters,
    ModelCard
  },
  data () {
    return {
      tags: '',
      result: true,
      paramTags: '',
      paramSearch: '',
      paramOrder: '',
      paramVerified: false,
      resultSize: 10,
      page: 1,
      isLoading: true
    }
  },
  async mounted () {
    const search = this.$route.query.n
    if (search != null) this.paramSearch = search
    this.tags = await api.getTags()
    this.result = await api.search(this.paramSearch, this.paramTags, null, this.paramOrder, this.resultSize, this.page)
    this.isLoading = false
  },
  methods: {
    async changePage (page) {
      this.page = page
      this.result = await api.search(this.paramSearch, this.paramTags, null, this.paramOrder, this.resultSize, this.page)
    },
    async setSearch () {
      this.result = await api.search(this.paramSearch, this.paramTags, null, this.paramOrder, this.resultSize, this.page)
    },
    async setOrder (order) {
      this.paramOrder = order
      this.result = await api.search(this.paramSearch, this.paramTags, null, this.paramOrder, this.resultSize, this.page)
    },
    async setTags (tags, verifiedOnly) {
      this.paramTags = tags
      this.paramVerified = verifiedOnly
      this.result = await api.search(this.paramSearch, this.paramTags, null, this.paramOrder, this.resultSize, this.page)
    }
  }
}
</script>

<style scoped>
.search {
  padding-top: 50px;
}

.filterTitle {
  margin-left: 15px;
  margin-bottom: 0;
}

.searchTitle {
  margin-bottom: 5px;
}
</style>
